/*
 * LCD-Wecker mit grafischem Display (240x128 Pixel) und Controller UC1611s, Scott-Falk Hhn, "tables.h"
 * Men-Tabellen
 */

#ifndef TABLES_H_
#define TABLES_H_

#define MTABSIZE 6                                                // Gre eines Men-Eintrages in der folgenden Men-Tabelle

// Men-Tabellen mit folgenden Aufbau: Byte 0 - X-Koordinate der linken oberen Ecke
//                                     Byte 1 - Y-Koordinate der linken oberen Ecke
//                                     Byte 2 - X-Koordinate der rechten unteren Ecke
//                                     Byte 3 - Y-Koordinate der rechten unteren Ecke
//                                     Byte 4 - Aktion bei kurzer Berhrung (0 = keine Aktion)
//                                     Byte 5 - Aktion bei langer Berhrung (0 = keine Aktion)
//
//                                                                                                                        Aktion bei kurzer Berhrung             Aktion bei langer Berhrung
                                                                  // Men 0, Hauptbildschirm                              -------------------------------------   -------------------------------------
const char menu00[] PROGMEM = {  0,  0,  170,  67, 100,   1,      //   Bereich 0, Uhrzeit-Bereich                         Anzeige von Sekunden und Datum          Men -> Uhr stellen
                                 0,  72,  65, 127, 220,   9,      //   Bereich 1, Weckzeit 1                              Men -> Weckzeit 1 direkt einstellen    Men -> Weck-Programme
                                70,  72, 135, 127, 221,   9,      //   Bereich 2, Weckzeit 2                              Men -> Weckzeit 2 direkt einstellen    Men -> Weck-Programme
                               140,  72, 205, 127, 222,   9,      //   Bereich 3, Weckzeit 3                              Men -> Weckzeit 3 direkt einstellen    Men -> Weck-Programme
                               175,   0, 239,  23,   2,   2,      //   Bereich 4, Einstellung                             Men -> Einstellungen                   Men -> Einstellungen
                               175,  28, 239,  67, 172,   9,      //   Bereich 5, Modus (Programm/Manuell)                Wecker-Modus umschalten                 Men -> Weck-Programme
                               210,  72, 239,  97,   8,   6,      //   Bereich 6, DCF-Status                              Men -> System-Informationen            Men -> DCF77-Einstellungen
                               210, 102, 239, 127, 134,   7       //   Bereich 7, Lautsprecher-Status                     Lautsprecher-Status umschalten          Men -> Audio-Einstellungen
};
                                                                  // Men 1, Datum und Uhrzeit einstellen
const char menu01[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               181,  60, 239,  91, 101, 101,      //   Bereich 1, OK / Synchr. starten                    Men -> zurck, Zeit setzen / Synchr.   Men -> zurck, Zeit setzen / Synchr.
                               181,  96, 239, 127,  99,  99,      //   Bereich 2, Zurck                                  Men -> zurck                          Men -> zurck
                                 0,  60,  99,  91,   0,   0,      //   Bereich 3, Datum Anzeigefeld
                               104,  60, 171,  91,   0,   0,      //   Bereich 4, Uhrzeit Anzeigefeld
                                 4,  24,  31,  55, 102, 102,      //   Bereich 5, Tag erhhen                             Tag erhhen                             Tag erhhen
                                 4,  96,  31, 127, 103, 103,      //   Bereich 6, Tag vermindern                          Tag vermindern                          Tag vermindern
                                36,  24,  63,  55, 104, 104,      //   Bereich 7, Monat erhhen                           Monat erhhen                           Monat erhhen
                                36,  96,  63, 127, 105, 105,      //   Bereich 8, Monat vermindern                        Monat vermindern                        Monat vermindern
                                68,  24,  95,  55, 106, 106,      //   Bereich 9, Jahr erhhen                            Jahr erhhen                            Jahr erhhen
                                68,  96,  95, 127, 107, 107,      //   Bereich 10, Jahr vermindern                        Jahr vermindern                         Jahr vermindern
                               108,  24, 135,  55, 108, 108,      //   Bereich 11, Stunde erhhen                         Stunde erhhen                          Stunde erhhen
                               108,  96, 135, 127, 109, 109,      //   Bereich 12, Stunde vermindern                      Stunde vermindern                       Stunde vermindern
                               140,  24, 167,  55, 110, 110,      //   Bereich 13, Minute erhhen                         Minute erhhen                          Minute erhhen
                               140,  96, 167, 127, 111, 111,      //   Bereich 14, Minute vermindern                      Minute vermindern                       Minute vermindern
                               181,  24, 239,  55, 112, 112       //   Bereich 15, Sommerzeit-Automatik umschalten        Sommerzeit-Automatik umschalten         Sommerzeit-Automatik umschalten
};
                                                                  // Men 2, Einstellung
const char menu02[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               163,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24,  76,  55,   4,   4,      //   Bereich 2, Allgemeine Einstellungen                Men -> Allgemeine Einstellungen        Men -> Allgemeine Einstellungen
                                81,  24, 158,  55,   5,   5,      //   Bereich 3, Anzeige-Einstellungen                   Men -> Anzeige-Einstellungen           Men -> Anzeige-Einstellungen
                               163,  24, 239,  55,   6,   6,      //   Bereich 4, DCF-Einstellungen                       Men -> DCF77-Einstellungen             Men -> DCF77-Einstellungen
                                 0,  60,  76,  91,   7,   7,      //   Bereich 5, Audio-Einstellungen                     Men -> Audio-Einstellungen             Men -> Audio-Einstellungen
                                81,  60, 158,  91,   3,   3,      //   Bereich 6, Touchscreen kalibrieren                 Men -> Touchscreen kalibrieren         Men -> Touchscreen kalibrieren
                               163,  60, 239,  91,   8,   8,      //   Bereich 7, System-Informationen                    Men -> System-Informationen            Men -> System-Informationen
                                 0,  96,  76, 127,   1,   1,      //   Bereich 8, Datum und Uhrzeit                       Men -> Uhr stellen                     Men -> Uhr stellen
                                81,  96, 158, 127,   9,   9       //   Bereich 9, Weck-Programme                          Men -> Weck-Programme                  Men -> Weck-Programme
};
                                                                  // Men 3, Touchscreen kalibrieren
const char menu03[] PROGMEM = { 40,   0, 199,  16,   0,   0,      //   Bereich 0, Mentitel
                                40,  24, 199,  55,   0,   0,      //   Bereich 1, Hinweistext
                                90,  60, 149,  91,  99,  99,      //   Bereich 2, Zurck                                  Men -> Zurck                          Men -> Zurck
                                90,  96, 149, 127, 113, 113       //   Bereich 3, OK                                      Men -> Zurck, Kalibrierdaten spei.    Men -> Zurck, Kalibrierdaten spei.
};
                                                                  // Men 4, Allgemeine Einstellungen
const char menu04[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               180,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24,  27,  55, 114, 114,      //   Bereich 2, Sprache vermindern                      Sprache vermindern                      Sprache vermindern
                                32,  24, 207,  55,   0,   0,      //   Bereich 3, Sprache Anzeigefeld
                               212,  24, 239,  55, 115, 115,      //   Bereich 4, Sprache erhhen                         Sprache erhhen                         Sprache erhhen
                                 0,  60,  27,  91, 116, 116,      //   Bereich 5, LED-Modus vermindern                    LED-Modus vermindern                    LED-Modus vermindern
                                32,  60, 207,  91,   0,   0,      //   Bereich 6, LED-Modus Anzeigefeld
                               212,  60, 239,  91, 117, 117,      //   Bereich 7, LED-Modus erhhen                       LED-Modus erhhen                       LED-Modus erhhen
                                 0,  96,  27, 127, 215, 215,      //   Bereich 8, Schlummerzeit vermindern                Schlummerzeit vermindern                Schlummerzeit vermindern
                                32,  96, 138, 127,   0,   0,      //   Bereich 9, Schlummerzeit Anzeigefeld
                               143,  96, 170, 127, 216, 216       //   Bereich 10, Schlummerzeit erhhen                  Schlummerzeit erhhen                   Schlummerzeit erhhen
};
                                                                  // Men 5, Anzeige-Einstellungen
const char menu05[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               180,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24,  27,  55, 118, 118,      //   Bereich 2, Minimale Helligkeit vermindern          Minimale Helligkeit vermindern          Minimale Helligkeit vermindern
                                32,  24, 138,  55,   0,   0,      //   Bereich 3, Minimale Helligkeit Anzeigefeld
                               143,  24, 170,  55, 119, 119,      //   Bereich 4, Minimale Helligkeit erhhen             Minimale Helligkeit erhhen             Minimale Helligkeit erhhen
                                 0,  60,  27,  91, 120, 120,      //   Bereich 5, Maximale Helligkeit vermindern          Maximale Helligkeit vermindern          Minimale Helligkeit erhhen
                                32,  60, 138,  91,   0,   0,      //   Bereich 6, Maximale Helligkeit Anzeigefeld
                               143,  60, 170,  91, 121, 121,      //   Bereich 7, Maximale Helligkeit erhhen             Maximale Helligkeit erhhen             Minimale Helligkeit erhhen
                                 0,  96,  27, 127, 122, 122,      //   Bereich 8, Kontrast vermindern                     Kontrast vermindern                     Kontrast vermindern
                                32,  96, 138, 127,   0,   0,      //   Bereich 9, Kontrast Anzeigefeld
                               143,  96, 170, 127, 123, 123,      //   Bereich 10, Kontrast erhhen                       Kontrast erhhen                        Kontrast erhhen
                               180,  24, 239,  55, 124, 124,      //   Bereich 11, Alarm-Datum umschalten                 Alarm-Datum umschalten                  Alarm-Datum umschalten
                               180,  60, 239,  91, 136, 136       //   Bereich 12, Groziffernsatz umschalten             Groziffernsatz umschalten              Groziffernsatz umschalten
};
                                                                  // Men 6, DCF77-Einstellungen
const char menu06[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               180,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24, 100,  55, 125, 125,      //   Bereich 2, DCF-Invertierung umschalten             DCF-Invertierung umschalten             DCF-Invertierung umschalten
                                 0,  60, 100,  91, 126, 126,      //   Bereich 3, DCF-Pull-up umschalten                  DCF-Pull-up umschalten                  DCF-Pull-up umschalten
                                 0,  96, 100, 127, 127, 127,      //   Bereich 4, Feste DCF-Synchr.-Zeit umschalten       Feste DCF-Synchr.-Zeit umschalten       Feste DCF-Synchr.-Zeit umschalten
                               135,  24, 162,  55, 128, 128,      //   Bereich 5, DCF-Synchronisierungsstunde erhhen     DCF-Synchronisierungsstunde erhhen     DCF-Synchronisierungsstunde erhhen
                               131,  60, 198,  91,   0,   0,      //   Bereich 6, DCF-Synchr.-Stunde Anzeigefeld
                               135,  96, 162, 127, 129, 129       //   Bereich 7, DCF-Synchronisierungsstunde vermindern  DCF-Synchronisierungsstunde vermindern  DCF-Synchronisierungsstunde vermindern
};
                                                                  // Men 7, Audio-Einstellungen
const char menu07[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               163,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24,  27,  55, 130, 130,      //   Bereich 2, Weck-Ton-Nummer vermindern              Weck-Ton-Nummer vermindern              Weck-Ton-Nummer vermindern
                                32,  24, 207,  55,   0,   0,      //   Bereich 3, Weck-Ton-Nummer Anzeigefeld
                               212,  24, 239,  55, 131, 131,      //   Bereich 4, Weck-Ton-Nummer erhhen                 Weck-Ton-Nummer erhhen                 Weck-Ton-Nummer erhhen
                                 0,  60,  27,  91, 132, 132,      //   Bereich 5, Lautstrke vermindern                   Lautstrke vermindern                   Lautstrke vermindern
                                32,  60, 121,  91,   0,   0,      //   Bereich 6, Lautstrke Anzeigefeld
                               126,  60, 153,  91, 133, 133,      //   Bereich 7, Lautstrke erhhen                      Lautstrke erhhen                      Lautstrke erhhen
                                 0,  96,  27, 127, 134, 134,      //   Bereich 8, Lautsprecher-Status umschalten          Lautsprecher-Status umschalten          Lautsprecher-Status umschalten
                                32,  96, 153, 127, 135, 135,      //   Bereich 9, Weck-Ton testen                         Weck-Ton testen                         Weck-Ton testen
                               163,  60, 239,  91, 137, 137       //   Bereich 10, Lautstrke-Modus umschalten            Lautstrke-Modus umschalten             Lautstrke-Modus umschalten
};
                                                                  // Men 8, System-Informationen
const char menu08[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               163,  96, 239, 127,  99,  99       //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
};
                                                                  // Men 9, Weck-Programme
const char menu09[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               180, 105, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  32,  34,  49, 140, 187,      //   Bereich 2, Kalenderfeld 1                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                34,  32,  68,  49, 141, 188,      //   Bereich 3, Kalenderfeld 2                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                68,  32, 102,  49, 142, 189,      //   Bereich 4, Kalenderfeld 3                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               102,  32, 136,  49, 143, 190,      //   Bereich 5, Kalenderfeld 4                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               136,  32, 170,  49, 144, 191,      //   Bereich 6, Kalenderfeld 5                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               170,  32, 204,  49, 145, 192,      //   Bereich 7, Kalenderfeld 6                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               204,  32, 239,  49, 146, 193,      //   Bereich 8, Kalenderfeld 7                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                 0,  49,  34,  66, 147, 194,      //   Bereich 9, Kalenderfeld 8                          Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                34,  49,  68,  66, 148, 195,      //   Bereich 10, Kalenderfeld 9                         Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                68,  49, 102,  66, 149, 196,      //   Bereich 11, Kalenderfeld 10                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               102,  49, 136,  66, 150, 197,      //   Bereich 12, Kalenderfeld 11                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               136,  49, 170,  66, 151, 198,      //   Bereich 13, Kalenderfeld 12                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               170,  49, 204,  66, 152, 199,      //   Bereich 14, Kalenderfeld 13                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               204,  49, 239,  66, 153, 200,      //   Bereich 15, Kalenderfeld 14                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                 0,  66,  34,  83, 154, 201,      //   Bereich 16, Kalenderfeld 15                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                34,  66,  68,  83, 155, 202,      //   Bereich 17, Kalenderfeld 16                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                68,  66, 102,  83, 156, 203,      //   Bereich 18, Kalenderfeld 17                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               102,  66, 136,  83, 157, 204,      //   Bereich 19, Kalenderfeld 18                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               136,  66, 170,  83, 158, 205,      //   Bereich 20, Kalenderfeld 19                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               170,  66, 204,  83, 159, 206,      //   Bereich 21, Kalenderfeld 20                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               204,  66, 239,  83, 160, 207,      //   Bereich 22, Kalenderfeld 21                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                 0,  83,  34, 100, 161, 208,      //   Bereich 23, Kalenderfeld 22                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                34,  83,  68, 100, 162, 209,      //   Bereich 24, Kalenderfeld 23                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                68,  83, 102, 100, 163, 210,      //   Bereich 25, Kalenderfeld 24                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               102,  83, 136, 100, 164, 211,      //   Bereich 26, Kalenderfeld 25                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               136,  83, 170, 100, 165, 212,      //   Bereich 27, Kalenderfeld 26                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               170,  83, 204, 100, 166, 213,      //   Bereich 28, Kalenderfeld 27                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                               204,  83, 239, 100, 167, 214,      //   Bereich 29, Kalenderfeld 28                        Men -> Weckzeit einstellen             Weck-Programm-Position setzen
                                 0, 105,  22, 127, 168, 168,      //   Bereich 30, Weck-Programmfeld 1                    Weck-Programm umschalten                Weck-Programm umschalten
                                27, 105,  49, 127, 169, 169,      //   Bereich 31, Weck-Programmfeld 2                    Weck-Programm umschalten                Weck-Programm umschalten
                                54, 105,  76, 127, 170, 170,      //   Bereich 32, Weck-Programmfeld 3                    Weck-Programm umschalten                Weck-Programm umschalten
                                81, 105, 103, 127, 171, 171,      //   Bereich 33, Weck-Programmfeld 4                    Weck-Programm umschalten                Weck-Programm umschalten
                               113, 105, 170, 127,  12,  12       //   Bereich 34, Anzahl der Tage                        Anzahl der Tage einstellen              Anzahl der Tage einstellen
};
                                                                  // Men 10, Weckzeit und Programme (Hinweis auf fehlende Uhrzeit)
const char menu10[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               163,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                10,  43, 229,  75,   0,   0       //   Bereich 2, Hinweistext
};
                                                                  // Men 11, Weckzeit einstellen
const char menu11[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               185,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  24, 102,  55, 177, 181,      //   Bereich 2, Voreingestellte Weckzeit 1              Voreingestellte Weckzeit 1 nutzen       Voreingestellte Weckzeit 1 setzen
                                 0,  60, 102,  91, 178, 182,      //   Bereich 3, Voreingestellte Weckzeit 2              Voreingestellte Weckzeit 2 nutzen       Voreingestellte Weckzeit 2 setzen
                                 0,  96, 102, 127, 179, 183,      //   Bereich 4, Voreingestellte Weckzeit 3              Voreingestellte Weckzeit 3 nutzen       Voreingestellte Weckzeit 3 setzen
                               112,  60, 214,  91, 180, 180,      //   Bereich 5, Einstellbare Weckzeit                   Einstellbare Weckzeit nutzen            Einstellbare Weckzeit nutzen
                               116,  24, 143,  55, 173, 173,      //   Bereich 6, Stunde erhhen                          Stunde erhhen                          Stunde erhhen
                               116,  96, 143, 127, 174, 174,      //   Bereich 7, Stunde vermindern                       Stunde vermindern                       Stunde vermindern
                               148,  24, 175,  55, 175, 175,      //   Bereich 8, Minute erhhen                          Minute erhhen                          Minute erhhen
                               148,  96, 175, 127, 176, 176,      //   Bereich 9, Minute vermindern                       Minute vermindern                       Minute vermindern
                               185,  24, 239,  55, 184, 184       //   Bereich 10, Weckzeit lschen                       Weckzeit lschen                        Weckzeit lschen
};
                                                                  // Men 12, Anzahl der Tage einstellen
const char menu12[] PROGMEM = {  0,   0, 239,  16,   0,   0,      //   Bereich 0, Mentitel
                               163,  96, 239, 127,  99,  99,      //   Bereich 1, Zurck                                  Men -> Zurck                          Men -> Zurck
                                 0,  42,  27,  73, 185, 185,      //   Bereich 2, Anzahl der Tage vermindern              Anzahl der Tage vermindern              Anzahl der Tage vermindern
                                32,  42, 207,  73,   0,   0,      //   Bereich 3, Anzahl der Tage Anzeigefeld
                               212,  42, 239,  73, 186, 186       //   Bereich 4, Anzahl der Tage erhhen                 Anzahl der Tage erhhen                 Anzahl der Tage erhhen
};

// Pointerliste fr die Men-Tabelle

PGM_P const menulist[] PROGMEM =
{
  menu00, menu01, menu02, menu03, menu04, menu05, menu06, menu07, menu08, menu09, menu10, menu11, menu12
};

// Grenliste der Men-Tabelle (Anzahl der Bereiche)

uint8_t const menusize[] PROGMEM =
{
  sizeof(menu00) / MTABSIZE, sizeof(menu01) / MTABSIZE, sizeof(menu02) / MTABSIZE, sizeof(menu03) / MTABSIZE, sizeof(menu04) / MTABSIZE,
  sizeof(menu05) / MTABSIZE, sizeof(menu06) / MTABSIZE, sizeof(menu07) / MTABSIZE, sizeof(menu08) / MTABSIZE, sizeof(menu09) / MTABSIZE,
  sizeof(menu10) / MTABSIZE, sizeof(menu11) / MTABSIZE, sizeof(menu12) / MTABSIZE
};

// Tagestabellen fr die Zeitzhlung, normale Jahre mit 365 Tagen und Schaltjahre mit 366 Tagen

const uint8_t daytab1[] PROGMEM = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const uint8_t daytab2[] PROGMEM = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

// Wertetabellen fr minimale und maximale Helligkeit

const uint8_t bmitab[] PROGMEM = {0, 1, 2, 3, 4, 6, 8, 11, 15, 20};
const uint8_t bmatab[] PROGMEM = {48, 63, 80, 99, 120, 143, 168, 195, 224, 255};

#endif /* TABLES_H_ */
